﻿from tkinter import *
import time,math
BITX=200; BITY=200; a=1.5; b=0.25;XS=1; YS=1; ID=0
def array(N1,N2):
    return [[0 for i in range(N1)] for j in range(N2)]
BM=array(BITX,BITY)
#■ビットマップ生成
def initBM():#(ビットマップ1ピクセルを1×1のサイズの正方形で代替する)
    global BM, BITX,BITY, canvas
    for i in range(BITX):
        for j in range(BITY):
            BM[i][j]=canvas.create_rectangle(i,j,i,j, fill="#000077", outline='')
#■ビットマップクリア
def clearBitmap():#1×1のサイズの正方形の色を変更することでクリアとする
    global BM, BITX,BITY, canvas
    for i in range(BITX):
        for j in range(BITY):#以下、同じ色なら変更しないことで高速化
            if canvas.itemcget(BM[i][j],option='fill')!="#000077":
                canvas.itemconfig(BM[i][j],fill="#000077")
SCX = [  70, 200,  400,  800,  1600] # X方向スケール
SCY = [ 140, 400,  800, 1600,  3200] # Y方向スケール
X0  = [ 100, -70, -300, -800, -1750] # 画面上の原点 X
Y0  = [ 100, 100,  120,  145,   170] # 画面上の原点 Y
#■画面座標系に変換
def intX(X): global SCX, X0,ID; return int(X * SCX[ID] + X0[ID])
def intY(Y): global SCY, Y0,ID; return int(Y0[ID] - Y * SCY[ID])
#■表示用計算
def cmpIter():
    global XS,YN,canvas, BM,a,b
    #表示準備
    canvas.create_text(100,20,text="画面をクリアしています" ,
                       font=('Times',10),fill='yellow', tag="DT")
    root.update()
    clearBitmap()
    canvas.delete("DT")
    canvas.create_text(100,20,text="描画中です" ,
                       font=('Times',10),fill='yellow', tag="DT")
    root.update()
    #表示処理
    X= XS;Y=YS;LOOP=100000
    for k in range(LOOP):
        XN=1-a*X*X+Y;YN=b*X
        i=intX(XN); j=intY(YN)
        if i>=0 and i<BITX and j>=0 and j<BITY:#同じ色なら変更する必要なし
            if canvas.itemcget(BM[i][j],option='fill') !="#FFFFFF":
                canvas.itemconfig(BM[i][j],fill="#FFFFFF")
        X=XN; Y=YN;
    #表示終了処理
    canvas.delete("DT")
    root.update()
#■ マウスイベントによる次の描画
def leftMouseDown(event): 
    global ID; ID+=1
    if ID>4:ID=0
    cmpIter()
#■メイン処理
root=Tk()
root.title("Henon Map")
canvas=Canvas(root, width=BITX,height=BITY)
canvas.pack()
initBM()
root.update()
cmpIter()
#開始
canvas.bind("<Button-1>",leftMouseDown)
root.mainloop()


    
